#ifndef __X10_LANG_ACC_H
#define __X10_LANG_ACC_H

#include <x10rt.h>


#define X10_LANG_OBJECT_H_NODEPS
#include <x10/lang/Object.h>
#undef X10_LANG_OBJECT_H_NODEPS
namespace x10 { namespace lang { 
class Any;
} } 
namespace x10 { namespace lang { 
template<class TPMGL(T)> class GlobalRef;
} } 
namespace x10 { namespace lang { 
class Place;
} } 
namespace x10 { namespace lang { 

class Acc : public x10::lang::Object   {
    public:
    RTT_H_DECLS_CLASS
    
    virtual void supply(x10aux::ref<x10::lang::Any> t) = 0;
    virtual void reset(x10aux::ref<x10::lang::Any> t) = 0;
    virtual x10aux::ref<x10::lang::Any> result() = 0;
    virtual x10aux::ref<x10::lang::Any> calcResult() = 0;
    virtual void acceptResult(x10aux::ref<x10::lang::Any> a) = 0;
    virtual x10::lang::GlobalRef<x10aux::ref<x10::lang::Acc> > getRoot() = 0;
    virtual x10::lang::Place home() = 0;
    virtual x10aux::ref<x10::lang::Acc> x10__lang__Acc____x10__lang__Acc__this(
      );
    void _constructor();
    
    
    // Serialization
    public: virtual void _serialize_body(x10aux::serialization_buffer& buf);
    
    public: void _deserialize_body(x10aux::deserialization_buffer& buf);
    
};

} } 
#endif // X10_LANG_ACC_H

namespace x10 { namespace lang { 
class Acc;
} } 

#ifndef X10_LANG_ACC_H_NODEPS
#define X10_LANG_ACC_H_NODEPS
#ifndef X10_LANG_ACC_H_GENERICS
#define X10_LANG_ACC_H_GENERICS
#endif // X10_LANG_ACC_H_GENERICS
#endif // __X10_LANG_ACC_H_NODEPS
